=== bolt/lib/Core/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  DebugInfoDWARF
  Demangle
  MC
  MCDisassembler
  Object
  Support
  BinaryFormat
  AsmPrinter
  TargetParser
  )

add_llvm_library(LLVMBOLTCore
  AddressMap.cpp
  BinaryBasicBlock.cpp
  BinaryContext.cpp
  BinaryData.cpp
  BinaryEmitter.cpp
  BinaryFunction.cpp
  BinaryFunctionCallGraph.cpp
  BinaryFunctionProfile.cpp
  BinarySection.cpp
  CallGraph.cpp
  CallGraphWalker.cpp
  DebugData.cpp
  DebugNames.cpp
  DIEBuilder.cpp
  DynoStats.cpp
  Exceptions.cpp
  FunctionLayout.cpp
  GDBIndex.cpp
  HashUtilities.cpp
  JumpTable.cpp
  MCPlusBuilder.cpp
  ParallelUtilities.cpp
  Relocation.cpp

  NO_EXPORT
  DISABLE_LLVM_LINK_LLVM_DYLIB
  LINK_LIBS
  ${LLVM_PTHREAD_LIB}
  )

target_link_libraries(LLVMBOLTCore
  PRIVATE
  LLVMBOLTUtils
  )
